--- /dev/null
- DEF_VER=v0.5.GIT
+#!/bin/sh
+
+GVF=GIT-VERSION-FILE
- # First try git-describe, then see if there is a version file
- # (included in release tarballs), then default
- if VN=$(git describe --abbrev=4 HEAD 2>/dev/null) &&
++DEF_VER=0.6.GITGUI
+
+LF='
+'
+
- *$LF*) (exit 1) ;;
- v[0-9]*) : happy ;;
++tree_search ()
++{
++ head=$1
++ tree=$2
++ for p in $(git rev-list --parents --max-count=1 $head 2>/devnull)
++ do
++ test $tree = $(git rev-parse $p^{tree} 2>/dev/null) &&
++ vn=$(git describe --abbrev=4 $p 2>/dev/null) &&
++ case "$vn" in
++ gitgui-[0-9]*) echo $vn; break;;
++ esac
++ done
++}
++
++# We may be a subproject, so try looking for the merge
++# commit that supplied this directory content if we are
++# not at the toplevel. We probably will always be the
++# second parent in the commit, but we shouldn't rely on
++# that fact.
++#
++# If we are at the toplevel or the merge assumption fails
++# try looking for a gitgui-* tag, or fallback onto the
++# distributed version file.
++
++if prefix="$(git rev-parse --show-prefix 2>/dev/null)"
++ test -n "$prefix" &&
++ head=$(git rev-list --max-count=1 HEAD -- . 2>/dev/null) &&
++ tree=$(git rev-parse --verify "HEAD:$prefix" 2>/dev/null) &&
++ VN=$(tree_search $head $tree)
+ case "$VN" in
- VN=$(echo "$VN" | sed -e 's/-/./g');
++ gitgui-[0-9]*) : happy ;;
++ *) (exit 1) ;;
+ esac
+then
- VN=$(expr "$VN" : v*'\(.*\)')
-
++ VN=$(echo "$VN" | sed -e 's/^gitgui-//;s/-/./g');
++elif VN=$(git describe --abbrev=4 HEAD 2>/dev/null) &&
++ case "$VN" in
++ gitgui-[0-9]*) : happy ;;
++ *) (exit 1) ;;
++ esac
++then
++ VN=$(echo "$VN" | sed -e 's/^gitgui-//;s/-/./g');
+elif test -f version
+then
+ VN=$(cat version) || VN="$DEF_VER"
+else
+ VN="$DEF_VER"
+fi
+
- VC=$(sed -e 's/^GIT_VERSION = //' <$GVF)
+dirty=$(sh -c 'git diff-index --name-only HEAD' 2>/dev/null) || dirty=
+case "$dirty" in
+'')
+ ;;
+*)
+ VN="$VN-dirty" ;;
+esac
+
+if test -r $GVF
+then
- echo >&2 "GIT_VERSION = $VN"
- echo "GIT_VERSION = $VN" >$GVF
++ VC=$(sed -e 's/^GITGUI_VERSION = //' <$GVF)
+else
+ VC=unset
+fi
+test "$VN" = "$VC" || {
++ echo >&2 "GITGUI_VERSION = $VN"
++ echo "GITGUI_VERSION = $VN" >$GVF
+}
+
+
--- /dev/null
- gitexecdir := $(shell git --exec-path)
- INSTALL = install
+all::
+
+GIT-VERSION-FILE: .FORCE-GIT-VERSION-FILE
+ @$(SHELL_PATH) ./GIT-VERSION-GEN
+-include GIT-VERSION-FILE
+
+SCRIPT_SH = git-gui.sh
+GITGUI_BUILT_INS = git-citool
+ALL_PROGRAMS = $(GITGUI_BUILT_INS) $(patsubst %.sh,%,$(SCRIPT_SH))
+
+ifndef SHELL_PATH
+ SHELL_PATH = /bin/sh
+endif
+
-
++ifndef gitexecdir
++ gitexecdir := $(shell git --exec-path)
++endif
++
++ifndef INSTALL
++ INSTALL = install
++endif
+
+DESTDIR_SQ = $(subst ','\'',$(DESTDIR))
+gitexecdir_SQ = $(subst ','\'',$(gitexecdir))
- -e 's/@@GIT_VERSION@@/$(GIT_VERSION)/g' \
+SHELL_PATH_SQ = $(subst ','\'',$(SHELL_PATH))
+
+$(patsubst %.sh,%,$(SCRIPT_SH)) : % : %.sh
+ rm -f $@ $@+
+ sed -e '1s|#!.*/sh|#!$(SHELL_PATH_SQ)|' \
- # These can record GIT_VERSION
++ -e 's/@@GITGUI_VERSION@@/$(GITGUI_VERSION)/g' \
+ $@.sh >$@+
+ chmod +x $@+
+ mv $@+ $@
+
+$(GITGUI_BUILT_INS): git-gui
+ rm -f $@ && ln git-gui $@
+
- .PHONY: all install clean
++# These can record GITGUI_VERSION
+$(patsubst %.sh,%,$(SCRIPT_SH)): GIT-VERSION-FILE
+
+all:: $(ALL_PROGRAMS)
+
+install: all
+ $(INSTALL) -d -m755 '$(DESTDIR_SQ)$(gitexecdir_SQ)'
+ $(INSTALL) git-gui '$(DESTDIR_SQ)$(gitexecdir_SQ)'
+ $(foreach p,$(GITGUI_BUILT_INS), rm -f '$(DESTDIR_SQ)$(gitexecdir_SQ)/$p' && ln '$(DESTDIR_SQ)$(gitexecdir_SQ)/git-gui' '$(DESTDIR_SQ)$(gitexecdir_SQ)/$p' ;)
+
++dist-version:
++ @mkdir -p $(TARDIR)
++ @echo $(GITGUI_VERSION) > $(TARDIR)/version
++
+clean::
+ rm -f $(ALL_PROGRAMS) GIT-VERSION-FILE
+
++.PHONY: all install dist-version clean
+.PHONY: .FORCE-GIT-VERSION-FILE